Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# CollisionSolid Class Reference

The abstract base class for all things that can collide with other things in the world, and all the things they can collide with (except geometry). More...

Inheritance diagram for CollisionSolid:

List of all members.

## Public Member Functions
| clearEffectiveNormal ()
| Removes the normal previously set by set_effective_normal().
BoundingVolume const | getBounds ()
| Returns the solid's bounding volume.
Point3 | getCollisionOrigin ()
Vec3 const | getEffectiveNormal ()
| Returns the normal that was set by set_effective_normal().
bool | getRespectEffectiveNormal ()
| See set_respect_effective_normal().
bool | hasEffectiveNormal ()
| Returns true if a special normal was set by set_effective_normal(), false otherwise.
bool | isTangible ()
| Returns whether the solid is considered 'tangible' or not.
| output (ostream out)
| setBounds (BoundingVolume const bounding_volume)
| Returns the solid's bounding volume.
| setEffectiveNormal (Vec3 const effective_normal)
| Records a false normal for this CollisionSolid that will be reported by the collision system with all collisions into it, instead of its actual normal.
| setRespectEffectiveNormal (bool respect_effective_normal)
| This is only meaningful for CollisionSolids that will be added to a traverser as colliders.
| setTangible (bool tangible)
| Sets the current state of the 'tangible' flag.
| write (ostream out)
| write (ostream out, int indent_level)
## Static Public Member Functions
static TypeHandle | getClassType ()

## Detailed Description

The abstract base class for all things that can collide with other things in the world, and all the things they can collide with (except geometry).

This class and its derivatives really work very similarly to the way BoundingVolume and all of its derivatives work. There's a different subclass for each basic shape of solid, and double-dispatch function calls handle the subset of the N*N intersection tests that we care about.

## Member Function Documentation

clearEffectiveNormal | ( |  | ) |

Removes the normal previously set by set_effective_normal().

BoundingVolume const getBounds | ( |  | ) |

Returns the solid's bounding volume.

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from CopyOnWriteObject.

Reimplemented in CollisionBox, CollisionPlane, CollisionFloorMesh, CollisionPolygon, CollisionSphere, CollisionInvSphere, CollisionRay, CollisionLine, CollisionParabola, CollisionSegment, and CollisionTube.

Point3 getCollisionOrigin | ( |  | ) |

Vec3 const getEffectiveNormal | ( |  | ) |

Returns the normal that was set by set_effective_normal().

It is an error to call this unless has_effective_normal() returns true.

bool getRespectEffectiveNormal | ( |  | ) |

See set_respect_effective_normal().

bool hasEffectiveNormal | ( |  | ) |

Returns true if a special normal was set by set_effective_normal(), false otherwise.

bool isTangible | ( |  | ) |

Returns whether the solid is considered 'tangible' or not.

An intangible solid has no effect in a CollisionHandlerPusher (except to throw an event); it's useful for defining 'trigger' planes and spheres, that cause an effect when passed through.

output | ( | ostream | out | ) |

setBounds | ( | BoundingVolume const | bounding_volume | ) |

Returns the solid's bounding volume.

setEffectiveNormal | ( | Vec3 const | effective_normal | ) |

Records a false normal for this CollisionSolid that will be reported by the collision system with all collisions into it, instead of its actual normal.

This is useful as a workaround for the problem of an avatar wanting to stand on a sloping ground; by storing a false normal, the ground appears to be perfectly level, and the avatar does not tend to slide down it.

setRespectEffectiveNormal | ( | bool | respect_effective_normal | ) |

This is only meaningful for CollisionSolids that will be added to a traverser as colliders.

It is normally true, but if set false, it means that this particular solid does not care about the "effective" normal of other solids it meets, but rather always uses the true normal.

setTangible | ( | bool | tangible | ) |

Sets the current state of the 'tangible' flag.

Set this true to make the solid tangible, so that a CollisionHandlerPusher will not allow another object to intersect it, or false to make it intangible, so that a CollisionHandlerPusher will ignore it except to throw an event.

write | ( | ostream | out,
|  | int | indent_level
| ) |  |

write | ( | ostream | out | ) |

All Classes Namespaces Functions Variables Enumerations Enumerator Properties